---
title: Intl
slug: Web/JavaScript/Reference/Global_Objects/Intl
tags:
  - Internationalization
  - Intl
  - JavaScript
  - Namespace
---
<div>{{JSRef}}</div>

<p class="summary">The <strong><code>Intl</code></strong> object is the namespace for the ECMAScript Internationalization API, which provides language sensitive string comparison, number formatting, and date and time formatting. The <strong><code>Intl</code></strong> object provides access to several constructors as well as functionality common to the internationalization constructors and other language sensitive functions.</p>

<h2 id="Constructor_properties">Constructor properties</h2>

<dl>
 <dt>{{jsxref("Global_Objects/Intl/Collator/Collator", "Intl.Collator()")}}</dt>
 <dd>Constructor for collators, which are objects that enable language-sensitive string comparison.</dd>
 <dt>{{jsxref("Global_Objects/Intl/DateTimeFormat/DateTimeFormat", "Intl.DateTimeFormat()")}}</dt>
 <dd>Constructor for objects that enable language-sensitive date and time formatting.</dd>
 <dt>{{jsxref("Global_Objects/Intl/DisplayNames/DisplayNames", "Intl.DisplayNames()")}}</dt>
 <dd>Constructor for objects that enable the consistent translation of language, region and script display names.</dd>
 <dt>{{jsxref("Global_Objects/Intl/ListFormat/ListFormat", "Intl.ListFormat()")}}</dt>
 <dd>Constructor for objects that enable language-sensitive list formatting.</dd>
 <dt>{{jsxref("Global_Objects/Intl/Locale/Locale", "Intl.Locale()")}}</dt>
 <dd>Constructor for objects that represents a Unicode locale identifier.</dd>
 <dt>{{jsxref("Global_Objects/Intl/NumberFormat/NumberFormat", "Intl.NumberFormat()")}}</dt>
 <dd>Constructor for objects that enable language-sensitive number formatting.</dd>
 <dt>{{jsxref("Global_Objects/Intl/PluralRules/PluralRules", "Intl.PluralRules()")}}</dt>
 <dd>Constructor for objects that enable plural-sensitive formatting and language-specific rules for plurals.</dd>
 <dt>{{jsxref("Global_Objects/Intl/RelativeTimeFormat/RelativeTimeFormat", "Intl.RelativeTimeFormat()")}}</dt>
 <dd>Constructor for objects that enable language-sensitive relative time formatting.</dd>
</dl>

<h2 id="Static_methods">Static methods</h2>

<dl>
 <dt>{{jsxref("Intl.getCanonicalLocales()")}}</dt>
 <dd>Returns canonical locale names.</dd>
</dl>

<h2 id="Locale_identification_and_negotiation">Locale identification and negotiation</h2>

<p>The internationalization constructors as well as several language sensitive methods of other constructors (listed under <a href="#See_also">See also</a>) use a common pattern for identifying locales and determining the one they will actually use: they all accept <code>locales</code> and <code>options</code> arguments, and negotiate the requested locale(s) against the locales they support using an algorithm specified in the <code>options.localeMatcher</code> property.</p>

<h3 id="locales_argument">locales argument</h3>

<p>The <code>locales</code> argument requests that a particular locale (or a locale from a list of them) be considered for use in a given operation.  A single locale may be specified by either an <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Intl/Locale">Intl.Locale</a></code> object or a string that is a <a href="https://www.unicode.org/reports/tr35/tr35.html#BCP_47_Conformance">Unicode BCP 47 locale identifier</a>.  Multiple locales may be specified (and a best-supported locale determined by evaluating each of them in order and comparing against the locales supported by the implementation) by passing an array (or array-like object, with a <code>length</code> property and corresponding indexed elements) whose elements are either <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Intl/Locale">Intl.Locale</a></code> objects or values that convert to <a href="https://www.unicode.org/reports/tr35/tr35.html#BCP_47_Conformance">Unicode BCP 47 locale identifier </a>strings.  If the <code>locales</code> argument is not provided or is undefined, the runtime's default locale is used.</p>

<p>A Unicode BCP 47 locale identifier consists of</p>

<ol>
 <li>a language code,</li>
 <li>(optionally) a script code,</li>
 <li>(optionally) a region (or country) code,</li>
 <li>(optionally) one or more variant codes, and</li>
 <li>(optionally) one or more extension sequences,</li>
</ol>

<p>with all present components separated by hyphens.  Locale identifiers are case-insensitive ASCII.  However, it's conventional to use title case (first letter capitalized, successive letters lower case) for script code, upper case for region codes, and lower case for everything else.  For example:</p>

<ul>
 <li><code>"hi"</code>: Hindi (language)</li>
 <li><code>"de-AT"</code>: German (language) as used in Austria (region)</li>
 <li><code>"zh-Hans-CN"</code>: Chinese (language) written in simplified characters (script) as used in China (region)</li>
 <li><code>"en-emodeng"</code>: English (language) in the "Early modern English" dialect (variant)</li>
</ul>

<p>The subtags identifying languages, scripts, regions (including countries), and (rarely used) variants in Unicode BCP 47 locale identifiers are registered in the <a href="http://www.iana.org/assignments/language-subtag-registry">IANA Language Subtag Registry</a>.  This registry is periodically updated over time, and implementations may not always be up to date, so be careful not to rely too much on tags being universally supported.</p>

<p>BCP 47 also allows for extensions, each consisting of a single digit or letter (other than <code>"x"</code>) and one or more two- to eight-letter or digit tags, all separated by hyphens. JavaScript internationalization functions use the <code>"u"</code> (Unicode) extension, which can be used to request additional customization of {{jsxref("Collator")}}, {{jsxref("NumberFormat")}}, or {{jsxref("DateTimeFormat")}} objects. Examples:</p>

<ul>
 <li><code>"de-DE-u-co-phonebk"</code>: Use the phonebook variant of the German sort order, which interprets umlauted vowels as corresponding character pairs: ä → ae, ö → oe, ü → ue.</li>
 <li><code>"th-TH-u-nu-thai"</code>: Use Thai digits (๐, ๑, ๒, ๓, ๔, ๕, ๖, ๗, ๘, ๙) in number formatting.</li>
 <li><code>"ja-JP-u-ca-japanese"</code>: Use the Japanese calendar in date and time formatting, so that 2013 is expressed as the year 25 of the Heisei period, or 平成25.</li>
 <li><code>"en-GB-u-ca-islamic"</code>: use British English with the Islamic (Hijri) calendar, where the Gregorian date 14 October, 2017 is the Hijri date 24 Muharram, 1439.</li>
</ul>

<p>Other BCP 47 extension tags can be found in the <a href="https://github.com/unicode-org/cldr/tree/master/common/bcp47">Unicode CLDR Project</a>.</p>

<p>Finally, an extension using the letter <code>"x"</code> may appear, followed by one or one- to eight-letter or digit tags.  This extension allows applications to encode information for their own private use, that will be ignored by all <code>Intl</code> operations.</p>

<h3 id="Locale_negotiation">Locale negotiation</h3>

<p>The list of locales specified by the <code>locales</code> argument, after Unicode extensions have been removed from them, is interpreted as a prioritized request from the application. The runtime compares it against the locales it has available and picks the best one available. Two matching algorithms exist: the "<code>lookup</code>" matcher follows the Lookup algorithm specified in <a href="http://tools.ietf.org/html/rfc4647#section-3.4">BCP 47</a>; the "<code>best fit</code>" matcher lets the runtime provide a locale that's at least, but possibly more, suited for the request than the result of the Lookup algorithm. If the application doesn't provide a <code>locales</code> argument, or the runtime doesn't have a locale that matches the request, then the runtime's default locale is used. The matcher can be selected using a property of the <code>options</code> argument (see below).</p>

<p>If the selected language tag had a Unicode extension substring, that extension is now used to customize the constructed object or the behavior of the function. Each constructor or function supports only a subset of the keys defined for the Unicode extension, and the supported values often depend on the language tag. For example, the "<code>co</code>" key (collation) is only supported by {{jsxref("Collator")}}, and its "<code>phonebk</code>" value is only supported for German.</p>

<h3 id="options_argument">options argument</h3>

<p>The <code>options</code> argument must be an object with properties that vary between constructors and functions. If the <code>options</code> argument is not provided or is undefined, default values are used for all properties.</p>

<p>One property is supported by all language sensitive constructors and functions: The <code>localeMatcher</code> property, whose value must be a string "<code>lookup</code>" or "<code>best fit</code>" and which selects one of the locale matching algorithms described above.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Formatting_dates_and_numbers">Formatting dates and numbers</h3>

<p>You can use <code>Intl</code> to format dates and numbers in a form that's conventional for a specific language and region:</p>

<pre class="brush: js notranslate">const count = 26254.39;
const date = new Date("2012-05-24");

function log(locale) {
  console.log(
    `${new Intl.DateTimeFormat(locale).format(date)} ${new Intl.NumberFormat(locale).format(count)}`
  );
}

log("en-US");
// expected output: 5/24/2012 26,254.39

log("de-DE");
// expected output: 24.5.2012 26.254,39
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ES Int Draft', '#intl-object', 'Intl')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Intl")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>Introduction: <a href="https://norbertlindenberg.com/2012/12/ecmascript-internationalization-api/index.html">The ECMAScript Internationalization API</a></li>
 <li>Constructors
  <ul>
   <li>{{jsxref("Collator", "Intl.Collator")}}</li>
   <li>{{jsxref("DateTimeFormat", "Intl.DateTimeFormat")}}</li>
   <li>{{jsxref("ListFormat", "Intl.ListFormat")}}</li>
   <li>{{jsxref("NumberFormat", "Intl.NumberFormat")}}</li>
   <li>{{jsxref("PluralRules", "Intl.PluralRules")}}</li>
   <li>{{jsxref("RelativeTimeFormat", "Intl.RelativeTimeFormat")}}</li>
   <li>{{jsxref("Locale", "Intl.Locale")}}</li>
  </ul>
 </li>
 <li>Methods
  <ul>
   <li>{{jsxref("String.prototype.localeCompare()")}}</li>
   <li>{{jsxref("Number.prototype.toLocaleString()")}}</li>
   <li>{{jsxref("Date.prototype.toLocaleString()")}}</li>
   <li>{{jsxref("Date.prototype.toLocaleDateString()")}}</li>
   <li>{{jsxref("Date.prototype.toLocaleTimeString()")}}</li>
  </ul>
 </li>
</ul>
